<?php
namespace app\admin\controller;
use think\Config;
use think\Db;

/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2018/6/22
 * Time: 8:24
 */
class User extends BaseController{

    /**
     * 用户列表页面
     */
    public function index(){

        return $this->fetch();
    }

    /**
     * ajax获取用户列表
     */
    public function lst(){
        $page_start = input('get.iDisplayStart');
        $page_size = input('get.iDisplayLength');
        $where = '1=1';
        $kw = input('get.kw', '');
        if($kw != ''){
            $where = $where.' AND `user_name` = \''.$kw.'\' ';
        }
        $lst = Db::name('user')->field('id,user_name,user_pwd,user_type,days,powers,times,use_times,total_times,use_time,create_time')->where($where)->order('id DESC')->limit($page_start, $page_size)->select();
        $user_free_type = Config::get('user_free_type');
        foreach ($lst as $k=>$v){
            $lst[$k]['user_type'] = $user_free_type[$v['user_type']];
            if($v['days'] == '0'){
                $lst[$k]['days'] = '永久';
            }
            $power_arr = explode(',', $lst[$k]['powers']);
            $power_str = '';
            $web_site = Config::get('web_site_name');
            foreach ($power_arr as $ar){
                $power_str = $power_str.$web_site[$ar];
            }
            $lst[$k]['powers'] = $power_str;
        }
        $count = Db::name('user')->where($where)->count('id');
        $res = [
            'sEcho' => input('get.sEcho'),
            'iTotalRecords' => $count,
            'iTotalDisplayRecords' => $count,
            'aData' => $lst
        ];
        return json($res);
    }

    /**
     * 添加用户
     */
    public function add_edit(){
        $id = input('get.id');
        $param = input('post.');
        if($param){
            if(!isset($param['site']) || count($param['site']) == 0){
                return json(['status'=>-1, 'msg'=>'请选择权限']);
            }
            if($param['user_type'] == 1 && $param['total_times']<$param['times']){
                return json(['status'=>-1, 'msg'=>'总次数必须大于每日次数']);
            }
            $powers = implode($param['site'], ',');
            $user = [
                'user_type' => $param['user_type'],
                'user_name' => $param['user_name'],
                'user_pwd' => $param['user_pwd'],
                'days' => $param['days'],
                'times' => $param['times'],
                'total_times' => $param['total_times'],
                'powers' => $powers,
                'create_time' => date('Y-m-d H:i:s'),
                'update_time' => date('Y-m-d H:i:s'),
            ];
            $num = Db::name('user')->insert($user);
            if($num > 0){
                Db::name('power')->commit();
                return json(['status'=>1, 'msg'=>'添加成功']);
            }else{
                Db::name('power')->rollback();
                return json(['status'=>-1, 'msg'=>'添加失败,请联系开发者']);
            }
        }
        $vo = [];
        if(empty($id)){
            $user_name = rand(100000, 999999);
            $vo = Db::name('user')->where(['user_name'=>$user_name])->find();
            $num = 0;
            while ($vo){
                $user_name = rand(100000, 999999);
                $vo = Db::name('user')->where(['user_name'=>$user_name])->find();
                $num = $num + 1;
                if($num>5){
                    dd('随机生成账号重复次数过多,请联系开发者QQ：2625562627');
                    break;
                }
            }
            $user_pwd = rand(1000,9999);
            $vo['id'] = '';
            $vo['user_name'] = $user_name;
            $vo['user_pwd'] = $user_pwd;
            $vo['times'] = '';
            $vo['days'] = '';
        }else{
            $vo = Db::name('user')->where(['id'=>$id])->find();
        }
        $site = Config::get('web_site_name');
        $site_arr = [];
        foreach ($site as $k=>$v){
            $site_arr[] = [
                'k' => $k,
                'v' => $v
            ];
        }
        $free_type = Config::get('user_free_type');
        $free_type_arr = [];
        foreach ($free_type as $a=>$b){
            $free_type_arr[] = [
                'k' => $a,
                'v' => $b
            ];
        }
        $this->assign('vo', $vo);
        $this->assign('site_arr', $site_arr);
        $this->assign('free_type', $free_type_arr);
        return $this->fetch();
    }

    /**
     * 批量添加用户
     */
    public function batch_add(){
        $param = input('post.');
        if($param){
            if($param['user_type'] == 1 && $param['total_times']<$param['times']){
                return json(['status'=>-1, 'msg'=>'总次数必须大于每日次数']);
            }
            $num = $param['num'];
            if($num > 20){
                $num = 20;
            }
            $userList = [];
            $powers = implode($param['site'], ',');
            for($i=0; $i<$num; $i++){
                $user_name = rand(100000, 999999);
                $vo = Db::name('user')->where(['user_name'=>$user_name])->find();
                $t = 0;
                while ($vo){
                    $t = $t + 1;
                    if($t > 5){
                        return json(['status'=>-1, 'msg'=>'随机生成账号重复次数过多,请联系开发者QQ：2625562627']);
                    }
                    $user_name = rand(100000, 999999);
                    $vo = Db::name('user')->where(['user_name'=>$user_name])->find();
                }
                $user_pwd = rand(1000,9999);
                $user = [
                    'user_type' => $param['user_type'],
                    'user_name' => $user_name,
                    'user_pwd' => $user_pwd,
                    'days' => $param['days'],
                    'times' => $param['times'],
                    'total_times' => $param['total_times'],
                    'powers' => $powers,
                    'create_time' => date('Y-m-d H:i:s'),
                    'update_time' => date('Y-m-d H:i:s')
                ];
                $userList[] = $user;
            }
            $res = Db::name('user')->insertAll($userList);
            if($res){
                return json(['status'=>1, 'msg'=>'批量添加成功']);
            }else{
                return json(['status'=>-1, 'msg'=>'批量添加失败']);
            }
        }
        $free_type = Config::get('user_free_type');
        $free_type_arr = [];
        foreach ($free_type as $a=>$b){
            $free_type_arr[] = [
                'k' => $a,
                'v' => $b
            ];
        }
        $site = Config::get('web_site_name');
        $site_arr = [];
        foreach ($site as $k=>$v){
            $site_arr[] = [
                'k' => $k,
                'v' => $v
            ];
        }
        $this->assign('site_arr', $site_arr);
        $this->assign('free_type', $free_type_arr);
        return $this->fetch();
    }

    /**
     * 删除会员信息
     */
    public function del(){
        $id = input('post.id');
        Db::name('user')->where(['id'=>$id])->delete();
        return json(['status'=>1, 'msg'=>'删除成功']);
    }


    /**
     * 导出账号
     * @return mixed
     */
    public function export_user(){
        $lst = Db::name('user')->field('id,user_name,user_pwd')->where('use_time is null')->order('id DESC')->limit(50)->select();
        $content = '';
        foreach ($lst as $vo){
            $content = $content.'账号'.$vo['user_name'].'密码'.$vo['user_pwd'].'BR';
        }
        $this->assign('content', $content);
        return $this->fetch();
    }
}