<?php
namespace app\index\controller;

use think\Config;
use think\Db;

class Index extends IndexController {

    /**
     * 网站首页
     * @return mixed
     */
    public function index(){
        $system = Db::name('system')->where(['id'=>1])->find();
        $this->assign('system', $system);
        return $this->fetch();
    }

    /**
     * 获取用户剩余解析量
     */
    public function accountMsg(){
        $user_info = session('user_info');
        $uid = $user_info['uid'];
        $user = Db::name('user')->where(['id'=>$uid])->find();
        $power_lst = Db::name('power')->where(['uid'=>$uid])->select();
        $times = [];
        $permissions = [];
        $site_arr = Config::get('web_site_name');
        $rest_times = '无限';
        if($user['user_type'] == '1'){//表示按次下载
            $rest_times = $user['total_times']-$user['use_times'];
        }
        foreach ($power_lst as $power){
            $site_name = $site_arr[$power['web_type']];
            $times[] = $site_name.'['.$power['times'].'/'.$rest_times.']次';
            $permissions[] = '['.$site_name.']';
        }

        $livetime = [];
        if($user['days'] == '0'){
            $livetime[] = '[永久]';
        }else{
            $livetime[] = '['.$user['days'].'天]';
        }
        $user_type = Config::get('user_free_type')[$user['user_type']];
        $res = [
            'status' => 0,
            'message' => '查询成功',
            'result' => true,
            'data' => [
                'user_type' => $user_type,
                'livetime' => $livetime,
                'times' => $times,
                'permissions' => $permissions,
            ],
        ];
        return json($res);
    }

    /**
     * 用户登录
     */
    public function login(){
        $param = input('post.');
        if($param){
            $vo = Db::name('user')->field('id,user_name,user_pwd,use_time,days')->where(['user_name'=>$param['user_name']])->find();
            if($vo){
                if($param['user_pwd'] == $vo['user_pwd']){
                    if(empty($vo['use_time'])){
                        Db::name('user')->where(['id'=>$vo['id']])->update(['use_time'=>date('Y-m-d H:i:s')]);
                    }else{
                        if($vo['days'] != '0') {
                            $over_time = date('Y-m-d H:i:s', strtotime('+' . $vo['days'] . ' day', strtotime($vo['use_time'])));
                            if (time() > strtotime($over_time)) {
                                return json(['status' => 2, 'message' => '账户已过期', 'result' => false]);
                            }
                        }
                    }
                    $userInfo = [
                        'uid' => $vo['id'],
                        'username' => $vo['user_name']
                    ];
                    session('user_info', $userInfo);
                    $res = [
                        'status' => 0,
                        'message' => '登录成功',
                        'result' => true
                    ];
                    return json($res);
                }
            }
            return json(array('status'=>1, 'message'=>'账号或密码不正确', 'result'=>false));
        }
        $system = Db::name('system')->find();
        $this->assign('qq', $system['qq']);
        return $this->fetch();
    }

    /**
     * 用户修改密码
     */
    public function modifyPwd(){
        $user_info = session('user_info');
        $uid = $user_info['uid'];
        $vo = Db::name('user')->field('id,user_name,user_pwd')->where(['id'=>$uid])->find();
        $oldpwd = input('post.oldpwd');
        if($oldpwd == $vo['user_pwd']){
            $password = input('post.password');
            Db::name('user')->where(['id'=>$uid])->update(['user_pwd'=>$password]);
            $res = [
                'status' => '0',
                'message' => '修改密码成功',
                'result' => true
            ];
            return json($res);
        }else{
            return json(['status'=>-1, 'message'=>'原密码不正确']);
        }
    }

    /**
     * 用户退出
     */
    public function logouts(){
        session('user_info', null);
        return $this->redirect(url('index/login'));
    }

    /**
     * 解析直链
     */
    public function parse(){
        $url = input('post.url');
        if(strpos($url, '58pic.com')>0){//千图网
            $res = $this->qiantu($url);
            return json($res);
        }
        if(strpos($url, 'nipic.com')>0){//昵图网
            $res = $this->nipic($url);
            return json($res);
        }
        if(strpos($url, '0sheji.com')>0){//90设计
            $res = $this->sheji90($url);
            return json($res);
        }
        if(strpos($url, '88ku.com')>0){//千库网
            $res = $this->qianku($url);
            return json($res);
        }
        if(strpos($url, '1yuansu.com')>0){//觅元素
            $res = $this->mitu($url);
            return json($res);
        }
        if(strpos($url, 'baotu.com')>0){//包图
            $res = $this->baotu($url);
            return json($res);
        }
        if(strpos($url, '699pic.com')>0){
            $res = $this->shetu($url);
            return json($res);
        }
        if(strpos($url, 'docer.com')>0){//稻壳儿
            $res = $this->docer($url);
            return json($res);
        }
      	if(strpos($url, '88tph.com')>0){//图品汇
            $res = $this->tupinhui($url);
            return json($res);
        }
      	if(strpos($url, '125pic.com')>0){//全图网
            $res = $this->quantu($url);
            return json($res);
        }
        $res = [
            'status' => 2,
            'message' => '该站点暂不支持解析',
            'result' => false,
            'type' => 0,
        ];
        return json($res);
    }

    /**
     * 解析成功减少一次次数
     */
    public function def_times($web_type){
        $user_info = session('user_info');
        $uid = $user_info['uid'];
        $where = [
            'uid' => $uid,
            'web_type' => $web_type
        ];
        $power = Db::name('power')->where($where)->find();
        $times = $power['times'] - 1;
        $up = [
            'times' => $times,
            'update_time' => date('Y-m-d H:i:s')
        ];
        Db::name('power')->where(['id'=>$power['id']])->update($up);
        $user = Db::name('user')->where(['id'=>$uid])->find();
        $use_times = $user['use_times'] + 1;
        $user_up = [
            'use_times' => $use_times,
            'update_time' => date('Y-m-d H:i:s')
        ];
        Db::name('user')->where(['id'=>$user['id']])->update($user_up);
    }

    /**
     * 解析千图网下载直链
     */
    public function qiantu($url){
        $web_type = 0;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>0])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $type = cut_str($url, 'html?type=', '');
                $apiurl = 'https://dl.58pic.com/' . $id . '.html';
                if (!empty($type)) {
                    $apiurl = 'https://dl.58pic.com/' . $id . '.html?type=' . $type;
                }
                $header = [
                    'Host: dl.58pic.com',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
                    'Referer: ' . $url,
                    'Cookie: ' . $web['cookies'],
                ];
                $res = httpRequest($apiurl, 'GET', null, $header);
                $downurl = cut_str($res, 'attr-type="a1" href="', '"');
                if (empty($downurl)) {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    if (strpos($downurl, 'proxy') > 0) {
                        $this->def_times('0');
                        $this->updateTimesTime($web);
                        $res = [
                            'status' => 0,
                            'message' => '解析成功',
                            'result' => true,
                            'type' => 0,
                            'urlList' => [
                                $downurl,
                                $downurl
                            ]
                        ];
                        return $res;
                    } else {
                        $this->updatewebtime(['id' => $web['id']]);
                        $res = [
                            'status' => 2,
                            'message' => '解析失败,下载地址不正确',
                            'result' => false,
                            'type' => 0,
                        ];
                        return $res;
                    }
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

    /**
     * 解析昵图网下载直链
     */
    public function nipic($url){
        $web_type = 1;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>1])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        $id = cut_str($url, 'com/show/', '.html');
        if(empty($id)){
            $id = cut_str($url, 'id=', '#showMore');
            if(empty($id)){
                $id = cut_str($url, 'id=', '');
            }
        }
        if(empty($id)){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $geturl = 'http://down.nipic.com/download?id=' . $id . '#showMore';
                $getHeader = [
                    'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
                    'Host: down.nipic.com',
                    'Referer: http://www.nipic.com/show/' . $id . '.html',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Cookie: ' . $web['cookies'],
                ];
                $detail = httpRequest($geturl, 'GET', null, $getHeader);
                if (!$detail) {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,请稍后再试',
                        'result' => false,
                    ];
                    return $res;
                }
                $token = cut_str($detail, 'name="__RequestVerificationToken" type="hidden" value="', '"');
                $apiurl = 'http://down.nipic.com/ajax/download_go';
                $postHeader = [
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'Host: down.nipic.com',
                    'Origin: http://down.nipic.com',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Referer: http://down.nipic.com/download?id=' . $id,
                    'Cookie: ' . $web['cookies'],
                ];
                $postData = [
                    'id' => $id,
                    'kid' => '2',
                    '__RequestVerificationToken' => $token,
                ];
                $res = httpRequest($apiurl, 'POST', $postData, $postHeader);
                $res_arr = json_decode($res, 1);
                if ($res_arr['code'] == '2000') {
                    $this->def_times('1');
                    $this->updateTimesTime($web);
                    $downurl = $res_arr['data']['url'];
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                } else {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

    /**
     * 解析90设计下载直链
     */
    public function sheji90($url){
        $web_type = 2;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $apiurl = 'http://90sheji.com/index.php?m=inspireAjax&a=getDownloadLink';
                $header = [
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'Accept-Encoding: gzip, deflate',
                    'Accept-Language: zh-CN,zh;q=0.9',
                    'Content-Type: application/x-www-form-urlencoded; charset=UTF-8',
                    'Cookie: ' . $web['cookies'],
                    'Host: 90sheji.com',
                    'Origin: http://90sheji.com',
                    'Referer: http://90sheji.com/?m=Inspire&a=download&id=' . $id,
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'X-Requested-With: XMLHttpRequest',
                ];
                $res = httpRequest($apiurl, 'POST', ['id' => $id], $header);
                $res_arr = json_decode($res, 1);
                if ($res_arr['success'] == '0') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res_arr['link'];
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }
    /**
     * 解析千库网下载直链
     */
    public function qianku($url){
        $web_type = 3;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $detailHtml = httpRequest($url, 'GET', null, []);
                $m = cut_str($detailHtml, 'modelName = "', '"');
                if($m == 'element'){
                    if(strpos($detailHtml, '下载PSD')){
                        $apiurl = 'http://588ku.com/index.php?m=' . $m . '&a=downpsd&id=' . $id . '&tab=&refererUrl=' . urlencode($url);
                    }else{
                        $apiurl = 'http://588ku.com/index.php?m=' . $m . '&a=down&id=' . $id . '&tab=&pro=undefined&refererUrl=' . urlencode($url);
                    }
                }else if($m == 'Video'){
                    $apiurl = 'http://dl.588ku.com/down/rar?callback=handleResponse&type=5&picid=' . $id . '&refererUrl=' . urlencode($url);
                }else if($m == 'Office'){
                    $apiurl = 'http://dl.588ku.com/down/rar?callback=handleResponse&type=4&picid=' . $id . '&refererUrl=' . urlencode($url);
                }else if($m == 'Illus'){
                    $apiurl = 'http://588ku.com/index.php?m=Illus&a=downPsd&id=' . $id . '&refererUrl=' . urlencode($url);
                }else if($m == 'Templet'){
                    $apiurl = 'http://588ku.com/index.php?m=Download&a=downloadPSD&id=' . $id . '&picType=11&refererUrl=' . urlencode($url);
                }else if($m == 'BackgroundGallery'){
                    $apiurl = 'http://588ku.com/index.php?m=back&a=down&id=' . $id . '&refererUrl=' . urlencode($url);
                }else if($m == 'WordArt'){
                    $apiurl = 'http://dl.588ku.com/down/pic?callback=handleResponse&type=6&picid=' . $id . '&refererUrl=' . urlencode($url);
                }else if($m == 'Audio'){
                    $apiurl = 'http://dl.588ku.com/down/rar?callback=handleResponse&type=8&picid=' . $id . '&refererUrl=' . urlencode($url);
                }else{
                    $apiurl = 'http://588ku.com/index.php?m=' . $m . '&a=downloadPSD&id=' . $id . '&refererUrl=' . urlencode($url);
                }
                $header = [
                    'Host: 588ku.com',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'Referer: ' . $url,
                    'Cookie: ' . $web['cookies'],
                ];
                $dl_arr = [
                    'Office',
                    'Video',
                    'WordArt',
                    'Audio'
                ];
                if(in_array($m, $dl_arr)){
                    $header[0] = 'Host: dl.588ku.com';
                }
                $res = httpRequest($apiurl, 'GET', null, $header);
                if(in_array($m, $dl_arr)){
                    $res_str = cut_str($res, 'ponse(', ');');
                    $res_arr = json_decode($res_str, 1);
                    $res_arr = $res_arr['data'];
                }else{
                    $res_arr = json_decode($res, 1);
                }
                if ($res_arr['status'] != '0') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    if(isset($res_arr['url'])){
                        $downurl = get_content_url($res_arr['url'], $header);
                        $this->def_times($web_type);
                        $this->updateTimesTime($web);
                        $res = [
                            'status' => 0,
                            'message' => '解析成功',
                            'result' => true,
                            'type' => 0,
                            'urlList' => [
                                $downurl,
                                $downurl
                            ]
                        ];
                        return $res;
                    }else{
                        $res = [
                            'status' => 2,
                            'message' => '解析失败'.$res_arr['info'],
                            'result' => false,
                            'type' => 0,
                        ];
                        return $res;
                    }
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }
    /**
     * 解析觅图网下载直链
     */
    public function mitu($url){
        $web_type = 5;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/(\w+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $apiurl = 'http://www.51yuansu.com/index.php?m=ajax&a=down&id=' . $id;
                $header = [
                    'Host: www.51yuansu.com',
                    'Connection: keep-alive',
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Referer: ' . $url,
                    'Accept-Language: zh-CN,zh;q=0.9',
                    'Proxy-Connection: keep-alive',
                    'X-Requested-With: XMLHttpRequest',
                    'Cookie: ' . $web['cookies'],
                ];
                $res = httpRequest($apiurl, 'GET', null, $header);
                $res_arr = json_decode($res, 1);
                if ($res_arr['status'] != '0') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res_arr['url'];
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }
    /**
     * 解析包图网下载直链
     */
    public function baotu($url){
        $web_type = 6;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $apiurl = 'https://ibaotu.com/?m=downloadopen&a=open&id=' . $id . '&down_type=1';
                $header = [
                    'Host: ibaotu.com',
                    'Connection: keep-alive',
                    'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Referer: https://ibaotu.com/?m=download&id=' . $id,
                    'Cookie: ' . $web['cookies'],
                ];
                $res = get_content_url($apiurl, $header);

                if (!strpos($res, '.zip')) {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res;
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

    /**
     * 解析摄图网下载直链
     */
    public function shetu($url){
        $web_type = 7;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/-([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $apiurl = 'http://699pic.com/newdownload/design';
                $header = [
                    'Host: 699pic.com',
                    'Connection: keep-alive',
                    'Accept: */*',
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'Referer: ' . $url,
                    'Cookie: ' . $web['cookies'],
                ];
                $data = [
                    'pid' => $id,
                    'byso' => 0,
                    'bycat' => 0,
                    'filetype' => 1
                ];
                $res = httpRequest($apiurl, 'POST', $data, $header);
                $res_arr = json_decode($res, 1);
                if ($res_arr['state'] != '1') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res_arr['url'];
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

  	/**
     * 解析图品汇
     * @param $url
     * @return array|mixed
     */
    public function tupinhui($url){
        $web_type = 9;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/\/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $id = $arr[1];
                $apiurl = 'http://www.88tph.com/download/get.json';
                $header = [
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'Accept-Encoding: gzip, deflate',
                    'Accept-Language: zh-CN,zh;q=0.9',
                    'Content-Type: application/x-www-form-urlencoded; charset=UTF-8',
                    'Cookie: ' . $web['cookies'],
                    'Host: www.88tph.com',
                    'Origin: http://www.88tph.com',
                    'Referer: ' . $url,
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'X-Requested-With: XMLHttpRequest',
                ];
                $res = httpRequest($apiurl, 'POST', ['pid' => $id], $header);
                $res_arr = json_decode($res, 1);
                if ($res_arr['status'] != 'ok') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res_arr['url']['a'];
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

  
 	 /**
     * 解析全图网
     * @param $url http://www.125pic.com
     * @return array|mixed
     */
    public function quantu($url){
        $web_type = 8;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        $id = cut_str($url, 'sucai/', '');
        if(strlen($id) == 0){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            if($web['is_third'] == '1'){
                $res = $this->getThirdRes($web_type, $url, $web);
                return $res;
            } else {
                $apiurl = 'http://www.125pic.com/api/sucai/download';
                $header = [
                    'Accept: application/json, text/javascript, */*; q=0.01',
                    'Accept-Encoding: gzip, deflate',
                    'Accept-Language: zh-CN,zh;q=0.9',
                    'Content-Type: text/plain',
                    'Cookie: ' . $web['cookies'],
                    'Host: www.125pic.com',
                    'Origin: http://www.125pic.com',
                    'Referer: ' . $url,
                    'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                    'X-Requested-With: XMLHttpRequest',
                ];
                $res = httpJson($apiurl, 'POST', ['id' => $id, 't'=>time().'000'], $header);
                $res_arr = json_decode($res, 1);
                if ($res_arr['stat'] != '200') {
                    $this->updatewebtime(['id' => $web['id']]);
                    $res = [
                        'status' => 2,
                        'message' => '解析失败,下载地址获取失败',
                        'result' => false,
                        'type' => 0,
                    ];
                    return $res;
                } else {
                    $downurl = $res_arr['data']['url'];
                    $this->def_times($web_type);
                    $this->updateTimesTime($web);
                    $res = [
                        'status' => 0,
                        'message' => '解析成功',
                        'result' => true,
                        'type' => 0,
                        'urlList' => [
                            $downurl,
                            $downurl
                        ]
                    ];
                    return $res;
                }
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }
  
    /**
     * 解析稻壳儿
     */
    public function docer($url){
        $web_type = 21;
        $user_info = session('user_info');
        $power = Db::name('power')->field('id,times')->where(['uid'=>$user_info['uid'], 'web_type'=>$web_type])->find();
        if(count($power)>0){
            if($power['times'] < 1){
                $res = [
                    'status' => 2,
                    'message' => '当天解析次数已用完',
                    'result' => false,
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '没有该站点权限',
                'result' => false,
            ];
            return $res;
        }
        preg_match('/([0-9]+).html/', $url, $arr);
        if(count($arr)!=2){
            $res = [
                'status' => 2,
                'message' => '链接无效',
                'result' => false,
            ];
            return $res;
        }
        $web = $this->getweb(['web_type'=>$web_type]);
        if($web){
            $id = $arr[1];
            $apiurl = 'http://detail.docer.com/detail/dl?id='.$id;
            $header = [
                'Host: detail.docer.com',
                'Connection: keep-alive',
                'Accept: application/json, text/javascript, */*; q=0.01',
                'User-Agent: Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36',
                'Referer: ' . $url,
                'Cookie: ' . $web['cookies'],
            ];
            $res = httpRequest($apiurl, 'GET', null, $header);
            $res_arr = json_decode($res, 1);
            if ($res_arr['result'] != 'ok') {
                $this->updatewebtime(['id' => $web['id']]);
                $res = [
                    'status' => 2,
                    'message' => '解析失败,下载地址获取失败',
                    'result' => false,
                    'type' => 0,
                ];
                return $res;
            } else {
                $downurl = $res_arr['data'];
                $this->def_times($web_type);
                $this->updateTimesTime($web);
                $res = [
                    'status' => 0,
                    'message' => '解析成功',
                    'result' => true,
                    'type' => 0,
                    'urlList' => [
                        $downurl,
                        $downurl
                    ]
                ];
                return $res;
            }
        }else{
            $res = [
                'status' => 2,
                'message' => '该站点暂未开放',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }

    /**
     * 获取解析cookie
     * @param $where
     * @return array|false|\PDOStatement|string|\think\Model
     */
    public function getweb($where){
        $where = '`limit_times` <> `times` AND `limit_times` <> 0 AND `is_use` = 1 AND `web_type`='.$where['web_type'];
        $res = Db::name('web')->where($where)->order('update_time ASC')->find();
        return $res;
    }

    /**
     * 更新最后解析时间
     */
    public function updatewebtime($where){
        Db::name('web')->where($where)->update(['update_time'=>date('Y-m-d H:i:s')]);
    }

    /**
     * 更新解析次数和时间
     */
    public function updateTimesTime($web){
        if(strtotime(date('Y-m-d')) > strtotime($web['update_time'])){
            $times = 1;
        }else{
            $times = $web['times'] + 1;
        }
        Db::name('web')->where(['id' => $web['id']])->update(['times' => $times, 'update_time' => date('Y-m-d H:i:s')]);
    }

    /**
     * 获取第三方数据
     */
    public function getThirdRes($web_type, $url, $web){
        $apiurl = 'http://www.hods.cn/parse';
        $postDate = [
            'url' => $url,
        ];
        $res = httpRequestGet($apiurl, 'POST', $postDate, []);
        file_put_contents('res.txt', $res.PHP_EOL, FILE_APPEND);
        $res_arr = json_decode($res, 1);
        if($res_arr['status'] == '0'){
            $this->def_times($web_type);
            $this->updateTimesTime($web);
            return $res_arr;
        }else{
            httpRequestGet('http://www.hods.cn/', 'GET', [], []);
            httpRequestGet('http://www.hods.cn/login', 'POST', ['user_name'=>$web['username'], 'user_pwd'=>$web['password']], []);
            $this->updatewebtime(['id' => $web['id']]);
            $res = [
                'status' => 2,
                'message' => '解析失败,请重试',
                'result' => false,
                'type' => 0,
            ];
            return $res;
        }
    }
    public function thirdApi($apiurl){
        $data = ['id'=>input('id')];
        $res = httpRequestGet($apiurl, 'POST', $data, [], false);
        return json(json_decode($res, 1));
    }
    public function bgPNG(){
        $apiurl = Config::get('third_web_url').'/bgPNG';
        return $this->thirdApi($apiurl);
    }
    public function bgPSD(){
        $apiurl = Config::get('third_web_url').'/bgPSD';
        return $this->thirdApi($apiurl);
    }
    public function elePNG(){
        $apiurl = Config::get('third_web_url').'/elePNG';
        return $this->thirdApi($apiurl);
    }
    public function mbjpg(){
        $apiurl = Config::get('third_web_url').'/mbjpg';
        return $this->thirdApi($apiurl);
    }
    public function mbpsd(){
        $apiurl = Config::get('third_web_url').'/mbpsd';
        return $this->thirdApi($apiurl);
    }
    public function IllusDown(){
        $apiurl = Config::get('third_web_url').'/IllusDown';
        return $this->thirdApi($apiurl);
    }
    public function _IllusPSD(){
        $apiurl = Config::get('third_web_url').'/_IllusPSD';
        return $this->thirdApi($apiurl);
    }
    public function wordart(){
        $apiurl = Config::get('third_web_url').'/wordart';
        return $this->thirdApi($apiurl);
    }
    public function office(){
        $apiurl = Config::get('third_web_url').'/office';
        return $this->thirdApi($apiurl);
    }
    public function elePSD(){
        $apiurl = Config::get('third_web_url').'/elePSD';
        return $this->thirdApi($apiurl);
    }
}
