<?php
namespace app\index\controller;
use think\Controller;
use think\Db;
use think\Request;

/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2017/11/30
 * Time: 10:34
 */

class IndexController extends Controller{
    public function _initialize(){
        parent::_initialize();
        $request = Request::instance();
        $controller_name = strtolower($request->controller());
        $action_name = strtolower($request->action());
        $action = $controller_name . '/' . $action_name;

        $white_list = Config('web_white_list');
        $found = FALSE;
        foreach ($white_list as $url) {
            if (strtolower($url) == $action) {
                $found = TRUE;
            }
        }
        if (!$found && !is_logged_on()) {
            session ('login_last_url', get_current_url () );
            $this->error('请登录',url('index/login'));
        }
        $web_where = '`update_time`<\''.date('Y-m-d 00:00:00').'\' AND `times`=`limit_times` AND `limit_times`!=0';
        $web_list = Db::name('web')->field('id,times,is_use')->where($web_where)->select();
        if(count($web_list)>0){
            foreach ($web_list as $web){
                $save_data = [
                    'id' => $web['id'],
                    'times' => 0,
                    'is_use' => 1,
                    'update_time' => date('Y-m-d H:i:s')
                ];
                Db::name('web')->update($save_data);
            }
        }
        if(is_logged_on()){
            $user_info = session('user_info');
            $vo = Db::name('user')->where(['id'=>$user_info['uid']])->find();
            if(!$vo){
                //判断当前登录的用户是否被删除
                session('user_info', null);
                session ('login_last_url', get_current_url () );
                $this->error('请登录',url('index/login'));
            }else{
                if($vo['days'] != '0'){
                    //不是永久用户判断用户是否到期
                    $over_time = date('Y-m-d H:i:s', strtotime('+'.$vo['days'].' day', strtotime($vo['use_time'])));
                    if(time() > strtotime($over_time)){
                        session('user_info', null);
                        session ('login_last_url', get_current_url () );
                        $this->error('请登录',url('index/login'));
                    }
                }
                $power_arr = explode(',', $vo['powers']);
                foreach ($power_arr as $power){
                    $power_vo = Db::name('power')->where(['uid'=>$vo['id'],'web_type'=>$power])->find();
                    if($power_vo){
                        if(strtotime(date('Y-m-d')) > strtotime($power_vo['update_time'])){
                            $times = $vo['times'];
                            if($vo['user_type'] == '1'){
                                $rest_times = $vo['total_times'] - $vo['use_times'];
                                if($rest_times < $vo['times']){
                                    $times = $rest_times;
                                }
                            }
                            $up = [
                                'times' => $times,
                                'update_time' => date('Y-m-d H:i:s')
                            ];
                            Db::name('power')->where(['id'=>$power_vo['id']])->update($up);
                        }
                    }else{
                        $times = $vo['times'];
                        if($vo['user_type'] == '1'){
                            $rest_times = $vo['total_times'] - $vo['use_times'];
                            if($rest_times < $vo['times']){
                                $times = $rest_times;
                            }
                        }
                        $power_vo = [
                            'uid' => $vo['id'],
                            'web_type' => $power,
                            'times' => $times,
                            'create_time' => date('Y-m-d H:i:s'),
                            'update_time' => date('Y-m-d H:i:s')
                        ];
                        Db::name('power')->insert($power_vo);
                    }
                }
            }
        }
    }
}